/**
 * LOGICAL-PARADOX.ORG variable record manager library
 * Copyright (C)2004 satoshi akabane(akabane@logical-paradox.org)
 *
 * Release 1.0
 * Ep[W
 */
package org.logical_paradox.common.vrm;

import java.io.IOException;
import java.io.OutputStream;
import java.nio.ByteBuffer;
import java.nio.ByteOrder;
import java.util.Iterator;

import org.logical_paradox.common.io.AvailableList;
import org.logical_paradox.common.util.Cache;
import org.logical_paradox.common.util.PriorityCache;

/**
 * VRMŎgpAvailableList
 * 擪8oCǵCp\R[hXg̍ŏ̃R[hɑ΂
 * oCgψʁD<BR>
 * ȍ~CR[hTCY,̃R[h̃oCgψʂ̏ɂȂD<br>
 * p\ȃR[h͑傫Ń\[gĊi[Ă͂D
 * 
 * @author satoshi akabane@logical-paradox.org
 * @version 1.0
 */
public class VRMAvailableList extends AvailableList {
	private long offset;

	/**
	 * RXgN^
	 * LbVTCY͖
	 * @param filename t@C
	 */
	public VRMAvailableList(String filename) {
		super(filename);
	}
	/**
	 * RXgN^
	 * @param filename t@C
	 * @param size LbVTCY(0:)
	 */
	public VRMAvailableList(String filename, int size) {
		super(filename, size);
	}
	/**
	 * ̗p\XgŎgpLbVIuWFNg𐶐
	 * @param size
	 * @return
	 */
	protected Cache createCache(int size) {
		// worst-fit邽߂ɁCR[hTCY̑傫Ƀ\[gLbV쐬
		return new PriorityCache(size, PriorityCache.GREATER_FIRST);
	}
	/**
	 * oCg񂩂痘p\Xg𕜌
	 * @param buffer ͌
	 * @throws IOException t@CANZXɉ肪
	 */
	protected void restore(ByteBuffer buffer) throws IOException {
		// 擪R[h̃oCgψʂ擾
		if(buffer.hasRemaining()) {
			offset = buffer.getLong();
		} else {
			offset = 0;
		}
		while(buffer.hasRemaining()) {
			// p\R[h̃TCY擾
			int availableRecordSize = buffer.getInt();
			// ̃R[hւ̃|C^擾
			long nextptr = buffer.getLong();
			// R[h𕜌ăLbVɒǉ
			cache.add(new AvailableRecord(availableRecordSize, nextptr));
			if(nextptr < 0) {
				// Ō̃R[h܂Ŏ荞񂾂̂ŏI
				break;
			}
		}
	}
	/**
	 * ŏ̗p\R[h̃oCgψʂݒ肷
	 * @param o oCgψ
	 */
	public void setOffset(long o) {
		offset = o;
	}
	/**
	 * ŏ̗p\R[h̃oCgψʂԂ
	 * @return oCgψ
	 */
	public long getOffset() {
		return offset;
	}
	/**
	 * p\Xgt@C֏o͂
	 * @throws IOException t@Co͒ɉ炩̖肪
	 */
	public void flush() throws IOException {
		OutputStream out = getOutputStream();
		
		// p\R[h̍ŏ̃oCgI[_[o
		ByteBuffer buffer = ByteBuffer.allocate(8).order(ByteOrder.BIG_ENDIAN);
		buffer.putLong(offset);
		buffer.rewind();
		
		out.write(buffer.array());

		// R[hbody̏o
		AvailableRecord ar = null;
		for(Iterator it = cache.iterator(); it.hasNext();) {
			ar = (AvailableRecord)it.next();
			out.write(ar.byteStream());
		}
		
		// t@CďI
		out.flush();
		out.close();
	}

}
