/**
 * LOGICAL-PARADOX.ORG variable record manager library
 * Copyright (C)2004 satoshi akabane(akabane@logical-paradox.org)
 *
 * Release 1.0
 * Ep[W
 */
package org.logical_paradox.common.vrm;

import java.util.Random;

import org.logical_paradox.common.lang.StringByteStream;
import org.logical_paradox.common.util.StringUtils;

import junit.framework.TestCase;

/**
 * ϒR[ht@CǗNX̃eXg
 * 
 * @author satoshi akabane@logical-paradox.org
 * @version 1.0
 */
public class VariableRecordManagerTest extends TestCase {

	// o͂̃eXg
	public void testInOut() throws Exception {
		VariableRecordManagerMoc manager = new VariableRecordManagerMoc("sample", RecordFactory.getInstance());
		manager.open();

		manager.insert(new StringRecord(""));
		manager.insert(new StringRecord(""));
		manager.insert(new StringRecord(""));
		manager.insert(new StringRecord(""));
		manager.insert(new StringRecord(""));

		manager.close();
	}
	// R[hėp̃eXg
	public void testReuse() throws Exception {
		VariableRecordManagerMoc manager = new VariableRecordManagerMoc("sample", RecordFactory.getInstance());
		manager.open();

		manager.insert(new StringRecord(""));
		manager.insert(new StringRecord(""));
		manager.insert(new StringRecord(""));
		manager.insert(new StringRecord(""));

		manager.delete(0);
		long rno = manager.insert(new StringRecord(""));

		assertEquals("R[h̍ėpɖ肪", 0, rno);
		manager.close();
	}
	// R[h̃_ȏoɂ郌R[h̃eXg
	public void testAvailability() throws Exception {
		VariableRecordManagerMoc manager = new VariableRecordManagerMoc("sample", RecordFactory.getInstance());
		manager.open();

		Long[] recordNumbers = null;

		Random rand = new Random();

		for(int i = 0; i < 100; i++) {
			// _Ȓ̕Ńf[^𐶐
			// _ȕ8ȓƂ
			String generatedString = StringUtils.randomText(8, false);
//System.out.println(generatedString);
			manager.insert(new StringRecord(generatedString));

			if(rand.nextInt(100) < 30) {
				// 30%̊mŁCKȃR[hoč폜
				recordNumbers = (Long[])manager.getRecordNumbers().toArray(new Long[0]);
				long removeTarget = recordNumbers[rand.nextInt(recordNumbers.length)].longValue();

				manager.delete(removeTarget);
			}
		}

		/*
		 * R[h̑Ó𔻒肷
		 */
		recordNumbers = (Long[])manager.getRecordNumbers().toArray(new Long[0]);
		for(int cnt = 0; cnt < recordNumbers.length; cnt++) {
			long rno = recordNumbers[cnt].longValue();
			Record r = manager.get(rno);

			System.out.println(r.getObject());
			StringByteStream strb = (StringByteStream)r.getObject();
			String str = strb.getStringObject();

			// 1ȏ8ȓ̂͂ł
			assertTrue("R[hǂ", str.length() >= 1 && str.length() <= 8);
		}
		manager.close();
	}
}
